// Solution by team RFLM (1st place).
// Solution submitted after 68 minutes.
#include<bits/stdc++.h>
using namespace std;

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

#define fora(i, a, b) for (int i = (a); i < (b); i++)
#define ford(i, a, b) for (int i = (a); i >= (b); i--)
#define pr(x) cerr << #x << " = " << x << "\n";
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()

using ll = long long;
using ull = unsigned long long;

using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;
using vb = vector<bool>;
using vd = vector<double>;
using vs = vector<string>;

using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;

using vpii = vector<pii>;
using vpll = vector<pll>;
using vpdd = vector<pdd>;

const long double PI = 3.14159265358979323;
const long long MOD = 1e9 + 7;


mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count()); // uniform_int_distribution<int>(0, n)(rng)

ll rnd(ll n) {
    return uniform_int_distribution<ll>(0, n)(rng);
}

struct custom_hash { // unordered_map<long long, int, custom_hash> safe_map;
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }
    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return (size_t) splitmix64(x + FIXED_RANDOM);
    }
	size_t operator()(pair<uint64_t,uint64_t> x) const {
		static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
		return (size_t) (splitmix64(x.first + FIXED_RANDOM)^(splitmix64(x.second + FIXED_RANDOM) >> 1));
	}
};

ull modmul(ull a, ull b, ull M) {
	ll ret = a * b - M * ull(1.L / M * a * b);
	return ret + M * (ret < 0) - M * (ret >= (ll)M);
}

ll power(ll b, ll e, ll mod) {
	ull ans = 1;
	for (; e; b = modmul(b, b, mod), e /= 2)
		if (e & 1) ans = modmul(ans, b, mod);
	return ans;
}

long long modInverse(long long n, long long p) {
    return power(n, p-2, p);
}

long long ncr(long long arr[], long long n, long long r, long long p) {
    return ((arr[n] * modInverse(arr[r], p))%p * modInverse(arr[n-r], p))%p;
}

bool isPrime(ull n) {
	if (n < 2 || n % 6 % 4 != 1) return (n | 1) == 3;
	ull A[] = {2, 325, 9375, 28178, 450775, 9780504, 1795265022},
	    s = __builtin_ctzll(n-1), d = n >> s;
	for (ull a : A) {   // ^ count trailing zeroes
		ull p = power(a%n, d, n), i = s;
		while (p != 1 && p != n - 1 && a % n && i--)
			p = modmul(p, p, n);
		if (p != n-1 && i != s) return 0;
	}
	return 1;
}

ull pollard(ull n) {
	auto f = [n](ull x) { return modmul(x, x, n) + 1; };
	ull x = 0, y = 0, t = 0, prd = 2, i = 1, q;
	while (t++ % 40 || __gcd(prd, n) == 1) {
		if (x == y) x = ++i, y = f(x);
		if ((q = modmul(prd, max(x,y) - min(x,y), n))) prd = q;
		x = f(x), y = f(f(y));
	}
	return __gcd(prd, n);
}

vector<ull> factor(ull n) {
	if (n == 1) return {};
	if (isPrime(n)) return {n};
	ull x = pollard(n);
	auto l = factor(x), r = factor(n / x);
	l.insert(l.end(), all(r));
	return l;
}

struct Node {
    int nr;
    vector<Node*> edges;
    bool visited = false;
    bool active = false;
    int distance = 1e9;
    int val = 0;
    void reset() {
        visited = false;
        active = false;
        distance = 0;
    }
};

list<Node*> activeNodes;

void dfs(Node* node, int w) {
    if (node -> visited) {
        return;
    }
    if (node -> val > w) {
        return;
    }
    activeNodes.push_back(node);
    node -> visited = true;
    node -> active = true;
    for (Node* newNode: node -> edges) {
        if (!newNode -> active) {
            newNode -> distance = min(newNode -> distance, node -> distance + 1);
        }
        if (!newNode -> visited) {
            dfs(newNode, w);
        }
    }
    activeNodes.pop_back();
    node -> active = false;
}

void bfs(Node* node) {
    if (node -> visited) {
        return;
    }
    node -> visited = true;
    queue<Node*> q;
    for (q.push(node); !q.empty(); q.pop()) {
        node = q.front();
        for (Node* newNode: node -> edges) {
            if (!newNode -> visited) {
                newNode -> visited = true;
                newNode -> distance = node -> distance + 1;
                q.push(newNode);
            }
        }
    }
}

/**
 * Author: Johan Sannemo
 * Date: 2015-02-06
 * License: CC0
 * Source: Folklore
 * Status: Tested at Petrozavodsk
 * Description: Range Minimum Queries on an array. Returns
 * min(V[a], V[a + 1], ... V[b - 1]) in constant time.
 * Usage:
 *  RMQ rmq(values);
 *  rmq.query(inclusive, exclusive);
 * Time: $O(|V| \log |V| + Q)$
 * Status: stress-tested
 */
template<class T>
struct RMQ {
	vector<vector<T>> jmp;
	RMQ(const vector<T>& V) : jmp(1, V) {
		for (int pw = 1, k = 1; pw * 2 <= sz(V); pw *= 2, ++k) {
			jmp.emplace_back(sz(V) - pw * 2 + 1);
			rep(j,0,sz(jmp[k]))
				jmp[k][j] = max(jmp[k - 1][j], jmp[k - 1][j + pw]);
		}
	}
	T query(int a, int b) {
		assert(a < b); // or return inf if a == b
		int dep = 31 - __builtin_clz(b - a);
		return max(jmp[dep][a], jmp[dep][b - (1 << dep)]);
	}
};

int n,m,k,t,a,b,rez,sk,ab[505][505],mas[503][503];
vector<int> liel[505];
string s;
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    fora(i, 0, n) {
        fora(j, 0, m) {
            cin >> ab[i][j];
        }
    }
    fora(i, 0, n) {
        fora(j, 0, m) {
            liel[i].push_back(ab[i][j]);
        }
    }
    vector<RMQ<int>> x;
    fora(i, 0, n) {
        x.push_back(RMQ<int>(liel[i]));
    }
    fora(i, 0, n-k+1) {
        fora(j, 0, m-k+1) {
            for (int d = 0; d < k && i+d < n; d++) {
                mas[i][j] = max(mas[i][j], x[i+d].query(j, j+k));
            }
//            cout << mas[i][j] << " ";
        }
//        cout << "\n";
    }
    Node nodes[n][m];
    fora(i, 0, n-k+1) {
        fora(j, 0, m-k+1) {
            nodes[i][j].nr = i*m+j;
            nodes[i][j].val = mas[i][j];
            if (i > 0) {
                nodes[i][j].edges.push_back(&nodes[i-1][j]);
            }
            if (j > 0) {
                nodes[i][j].edges.push_back(&nodes[i][j-1]);
            }
            if (i < n-k) {
                nodes[i][j].edges.push_back(&nodes[i+1][j]);
            }
            if (j < m-k) {
                nodes[i][j].edges.push_back(&nodes[i][j+1]);
            }
        }
    }
    int l = 0;
    int r = 1000000000;
    while (l < r) {
        int c = l+(r-l)/2;
        dfs(&nodes[0][0], c);
        if (nodes[n-k][m-k].visited) {
            r = c;
        } else {
            l = c + 1;
        }
        fora(i, 0, n-k+1) {
            fora(j, 0, m-k+1) {
//                cout << nodes[i][j].visited << " ";
                nodes[i][j].reset();
            }
//            cout << "\n";
        }
    }
    cout << l+1;
    return 0;
}
