// Solution by team RFLM (1st place).
// Solution submitted after 26 minutes.
#include<bits/stdc++.h>
using namespace std;

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

#define fora(i, a, b) for (int i = (a); i < (b); i++)
#define ford(i, a, b) for (int i = (a); i >= (b); i--)
#define pr(x) cerr << #x << " = " << x << "\n";
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()

using ll = long long;
using ull = unsigned long long;

using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;
using vb = vector<bool>;
using vd = vector<double>;
using vs = vector<string>;

using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;

using vpii = vector<pii>;
using vpll = vector<pll>;
using vpdd = vector<pdd>;

const long double PI = 3.14159265358979323;
const long long MOD = 1e9 + 7;


mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count()); // uniform_int_distribution<int>(0, n)(rng)

ll rnd(ll n) {
    return uniform_int_distribution<ll>(0, n)(rng);
}

struct custom_hash { // unordered_map<long long, int, custom_hash> safe_map;
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }
    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return (size_t) splitmix64(x + FIXED_RANDOM);
    }
	size_t operator()(pair<uint64_t,uint64_t> x) const {
		static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
		return (size_t) (splitmix64(x.first + FIXED_RANDOM)^(splitmix64(x.second + FIXED_RANDOM) >> 1));
	}
};

ull modmul(ull a, ull b, ull M) {
	ll ret = a * b - M * ull(1.L / M * a * b);
	return ret + M * (ret < 0) - M * (ret >= (ll)M);
}

ll power(ll b, ll e, ll mod) {
	ull ans = 1;
	for (; e; b = modmul(b, b, mod), e /= 2)
		if (e & 1) ans = modmul(ans, b, mod);
	return ans;
}

long long modInverse(long long n, long long p) {
    return power(n, p-2, p);
}

long long ncr(long long arr[], long long n, long long r, long long p) {
    return ((arr[n] * modInverse(arr[r], p))%p * modInverse(arr[n-r], p))%p;
}

bool isPrime(ull n) {
	if (n < 2 || n % 6 % 4 != 1) return (n | 1) == 3;
	ull A[] = {2, 325, 9375, 28178, 450775, 9780504, 1795265022},
	    s = __builtin_ctzll(n-1), d = n >> s;
	for (ull a : A) {   // ^ count trailing zeroes
		ull p = power(a%n, d, n), i = s;
		while (p != 1 && p != n - 1 && a % n && i--)
			p = modmul(p, p, n);
		if (p != n-1 && i != s) return 0;
	}
	return 1;
}

ull pollard(ull n) {
	auto f = [n](ull x) { return modmul(x, x, n) + 1; };
	ull x = 0, y = 0, t = 0, prd = 2, i = 1, q;
	while (t++ % 40 || __gcd(prd, n) == 1) {
		if (x == y) x = ++i, y = f(x);
		if ((q = modmul(prd, max(x,y) - min(x,y), n))) prd = q;
		x = f(x), y = f(f(y));
	}
	return __gcd(prd, n);
}

vector<ull> factor(ull n) {
	if (n == 1) return {};
	if (isPrime(n)) return {n};
	ull x = pollard(n);
	auto l = factor(x), r = factor(n / x);
	l.insert(l.end(), all(r));
	return l;
}

struct Node {
    int nr;
    vector<Node*> edges;
    bool visited = false;
    bool active = false;
    int distance = 1e9;
    int val;
    ll dp[2] = {-1000000000000000000LL, -1000000000000000000LL};
    void reset() {
        visited = false;
        active = false;
        distance = 0;
    }
};

list<Node*> activeNodes;

void dfs(Node* node) {
    if (node -> visited) {
        return;
    }
    activeNodes.push_back(node);
    node -> visited = true;
    node -> active = true;
    node -> dp[0] = node -> val;
    ll liel[2] = {-1000000000000000000LL, -1000000000000000000LL};
    for (Node* newNode: node -> edges) {
        if (!newNode -> active) {
            newNode -> distance = min(newNode -> distance, node -> distance + 1);
        }
        if (!newNode -> visited) {
            dfs(newNode);
            node -> dp[1] = max(node -> dp[1], newNode -> dp[0]);
            node -> dp[1] = max(node -> dp[1], newNode -> dp[1]);
            if (newNode -> dp[0] > liel[0]) {
                liel[1] = liel[0];
                liel[0] = newNode -> dp[0];
            } else if (newNode -> dp[0] > liel[1]) {
                liel[1] = newNode -> dp[0];
            }
        }
    }
    node -> dp[1] = max(node -> dp[1], max(node -> dp[0] + liel[0], node -> dp[0] + liel[0] + liel[1]));
    node -> dp[0] = max(node -> dp[0], node -> dp[0] + liel[0]);
    node -> dp[1] = max(node -> dp[1], node -> dp[0]);
    activeNodes.pop_back();
    node -> active = false;
}

void bfs(Node* node) {
    if (node -> visited) {
        return;
    }
    node -> visited = true;
    queue<Node*> q;
    for (q.push(node); !q.empty(); q.pop()) {
        node = q.front();
        for (Node* newNode: node -> edges) {
            if (!newNode -> visited) {
                newNode -> visited = true;
                newNode -> distance = node -> distance + 1;
                q.push(newNode);
            }
        }
    }
}

Node nodes[1000006];
int n,m,k,t,a,b,rez,sk,mas[100005];
string s;

int uu = 0;

void read(Node* parent, int nn) {
    int k;
    fora(i, 0, nn) {
        parent -> edges.push_back(&nodes[uu]);
        cin >> nodes[uu].val >> k;
        nodes[uu].nr = uu;
        uu++;
        read(&nodes[uu-1], k);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    cin >> nodes[0].val >> k;
    nodes[0].nr = 0;
    uu++;
    read(&nodes[0], k);
    dfs(&nodes[0]);
//    fora(i, 0, n) {
//        cout << nodes[i].dp[0] << " " << nodes[i].dp[1] << "\n";
//    }
    cout << max(nodes[0].dp[0], nodes[0].dp[1]);
    return 0;
}
